'
'  svnpropertylog - v1.1 - 05/02/2016
'  Copyright (C) 2016 Antoine Beauchamp
'  The code & updates for the library can be found on http://end2endzone.com
'
' AUTHOR/LICENSE:
'  This library is free software; you can redistribute it and/or
'  modify it under the terms of the GNU Lesser General Public
'  License as published by the Free Software Foundation; either
'  version 3.0 of the License, or (at your option) any later version.
'
'  This library is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'  Lesser General Public License (LGPL-3.0) for more details.
'
'  You should have received a copy of the GNU Lesser General Public
'  License along with this library; if not, write to the Free Software
'  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
'
' DISCLAIMER:
'  This software is furnished "as is", without technical support, and with no 
'  warranty, express or implied, as to its usefulness for any purpose.
'
' PURPOSE:
'  The subversion application does not offer native support for identifying
'  changes to properties as easily as changes to files. The purpose of
'  this script is to allows a subversion user to find all revisions where
'  a change to a specific property occured.
'
'  Calling the script finds all revisions where a given property has been changed.
'  Usage:
'   Argument 0: Oldest revision number
'   Argument 1: Newest revision number
'   Argument 2: File or folder URL
'   Argument 3: Property name
'   Argument 4: Show property values? ( Must be 0 or 1 )
'
' HISTORY:
' 04/30/2016 v1.0 - Initial release.
' 05/02/2016 v1.1 - Small correction to license file & header.
'

Option Explicit

dim caption
caption = "Find svn property log"

dim svnNewestRevision
svnNewestRevision = InputBox("Enter NEWEST revision number", caption )

dim svnOldestRevision
svnOldestRevision = InputBox("Enter OLDEST revision number", caption )

dim svnUrl
svnUrl = InputBox("Enter subversion url", caption )

dim propertyNames
Set propertyNames = CreateObject("System.Collections.ArrayList")
propertyNames.Add "svn:eol-style"
propertyNames.Add "svn:executable"
propertyNames.Add "svn:externals"
propertyNames.Add "svn:ignore"
propertyNames.Add "svn:keywords"
propertyNames.Add "svn:needs-lock"
propertyNames.Add "svn:mime-type"
propertyNames.Add "svn:mergeinfo"
dim propertyNameIdx
propertyNameIdx = AskUserChoice("Which subversion property should be monitored ?", propertyNames, caption)
dim svnPropertyName
svnPropertyName = propertyNames.Item(propertyNameIdx)

dim showPropertyOptions
Set showPropertyOptions = CreateObject("System.Collections.ArrayList")
showPropertyOptions.Add "No"
showPropertyOptions.Add "Yes"
dim showPropertyOptionsIdx
showPropertyOptionsIdx = AskUserChoice("Would you like to show property values ?", showPropertyOptions, caption)


'Identify the command line script path
dim cmdLineVbsPath
cmdLineVbsPath = WScript.ScriptFullName
cmdLineVbsPath = Replace(cmdLineVbsPath, "Gui", "")
dim commandLine
commandLine = "cmd /c cscript //nologo """ & cmdLineVbsPath & """ " & svnNewestRevision & " " & svnOldestRevision & " """ & svnUrl & """ """ & svnPropertyName & """ " & showPropertyOptionsIdx & " & PAUSE"
'commandLine = "cmd /c START """" """ & cmdLineVbsPath & """ " & svnNewestRevision & " " & svnOldestRevision & " """ & svnUrl & """ """ & svnPropertyName & """ " & showPropertyOptionsIdx
'msgbox commandLine

'Launch the command line program
Dim oShell
Set oShell = WScript.CreateObject ("WScript.Shell")
oShell.run commandLine
Set oShell = Nothing




Function AskUserChoice(prompt, options, caption)
  'Build full prompt
  dim fullprompt
  fullprompt = prompt & vbNewLine & vbNewLine
  
  dim i
  for i = 0 to options.Count-1
    fullprompt = fullprompt & "    " & i & ".)  " & options.Item(i) & vbNewLine
  next

  'Loop until user enters a valid number or selects CANCEL
  dim response
  Do
      response = InputBox(fullprompt, caption)
      If response = "" Then WScript.Quit  'Detect Cancel
      If IsNumeric(response) then
        response = cint(response)
        if response >= 0 and response < options.Count Then Exit Do 'Detect value response.
      end if
  Loop

  'return user selection
  AskUserChoice = response
End Function
